/*****************************************************************************/
/****																	  ****/
/****				  Header File for SAY Library Version 1.82		  	  ****/
/****																	  ****/
/****			    Copyright (C) 1992,1995 NOWSOFT , YUTAKA AOKI		  ****/
/****																	  ****/
/*****************************************************************************/

#ifndef __SAYLIB_H__
#define __SAYLIB_H__

#include "sayh.h"

/*****						Type Definitions							*****/

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	void			*Poi;
	unsigned int	Bytes;
} TDataPack;

typedef struct
{
	unsigned char	EnvDataSu;
	unsigned char	FMDataSu;
	unsigned char	PSGDataSu;
	unsigned char	RythmDataSu;
	unsigned char	PCMDataSu;
	unsigned char	TailDataSu;
	
	TDataPack	Data[ 5+6+3+1+16+1 ];
} TStartInfo;

#define	_SAYERR		(CDrvInfoPoi->ErrNo)

/****						Variables									****/

extern TDrvInfo		far *CDrvInfoPoi;
extern TSndInfo		far *CSndInfoPoi;

/****						ProtoType Declarations						****/

int		far CResidentCheck( void );

void	far CSoundInit( void );
void	far CSoundAllStop( void );
void	far CSoundAllCont( void );

unsigned int	far CSoundStart( unsigned char MixFlg ,
								 unsigned char PriorityOrder ,
								 unsigned char Cnt , unsigned char Fade ,
								 TStartInfo far *Poi );
unsigned int	far CSoundFileLoad( unsigned char MixFlg ,
									unsigned char ProprityOrder ,
									unsigned char Cnt , unsigned char Fade ,
									char far *Poi );

void			far CSoundStop( unsigned int UserHnd );
void			far CSoundContinue( unsigned int UserHnd );
void			far CSoundRestart( unsigned int UserHnd );
void			far CSoundFree( unsigned int UserHnd );

void	far CSetTempo( unsigned int UserHnd , unsigned char Tempo );

void	far CSetPartMask( unsigned int PartMask );
void	far CSetVolume( unsigned char Vol );

void			far COPNAWrite( unsigned char Reg , unsigned char Dat );
void			far COPNBWrite( unsigned char Reg , unsigned char Dat );
unsigned char	far COPNARead( unsigned char Reg );

void	far CFadeStart( unsigned int UserHnd , unsigned char Step );
void	far CFadeStop( unsigned int UserHnd );
void	far CFadeClear( unsigned int UserHnd );
void	far CFadeWait( unsigned int UserHnd , unsigned char FadeLevel );
void	far CSetFadeLevel( unsigned int UserHnd , unsigned char FadeLevel );

void			far CTaskAllClear( void );
unsigned int	far CTaskReserve( unsigned int TaskSeg ,
								  unsigned int ParaSize );
int				far CTaskRemove( unsigned int UserHnd );
unsigned int	far CTaskSearch( unsigned char far *TaskName );
int				far CTaskOn( unsigned int UserHnd );
int				far CTaskOff( unsigned int UserHnd );

void			far CPCMRateSet( unsigned char Rate );

#ifdef __cplusplus
}
#endif

#endif
